--- old/usr/src/tools/smatch/src/smatch_struct_assignment.c	Tue May 19 02:50:35 2020
+++ new/usr/src/tools/smatch/src/smatch_struct_assignment.c	Tue May 19 02:50:35 2020
@@ -151,6 +151,9 @@
 	struct symbol *type;
 	struct expression *assign;
 
+	while (right && right->type == EXPR_ASSIGNMENT)
+		right = strip_parens(right->left);
+
 	type = get_type(left);
 	if (!type)
 		return;
@@ -234,7 +237,6 @@
 	struct expression *assign;
 	int op = '.';
 
-
 	if (__in_fake_assign)
 		return;
 	faked_expression = faked;
@@ -242,6 +244,9 @@
 	left = strip_expr(left);
 	right = strip_expr(right);
 
+	if (left->type == EXPR_PREOP && left->op == '*' && is_pointer(left))
+		left = preop_expression(left, '(');
+
 	struct_type = get_struct_type(left);
 	if (!struct_type) {
 		/*
